<script>
    function downloadData(name, data, nw) {
        //Internet Explorer
        if (navigator.msSaveBlob) {
            var blob = new Blob([data]); //Aplica o conteúdo para baixar
            navigator.msSaveBlob(blob, name); //Nome do arquivo
            return;
        }
        var body = document.body;
        var uridown = "data:application/octecstream," + encodeURIComponent(data);
        var el = document.createElement("a"); //Cria o link
        el.download = name; //Define o nome
        el.href = uridown; //Define a url

        //Adiciona uma classe css pra ocultar
        el.className = "hide-link";
        //Força abrir em uma nova janela
        if (nw) {
            el.target = "_blank";
        }
        //Adiciona no corpo da página (necessário para evitar comportamento variado em diferentes navegadores)
        body.appendChild(el);
        if (el.fireEvent) {
            //Simula o click pra navegadores com suporte ao fireEvent
            el.fireEvent("onclick");
        } else {
            //Simula o click com MouseEvents
            var evObj = document.createEvent("MouseEvents");
            evObj.initEvent("click", true, false);
            el.dispatchEvent(evObj);
        }
        //Remove o link da página
        setTimeout(function() {
            body.removeChild(el);
        }, 100);
    }

    var dado_json, dado_sql;
    function salvar_json(){
        downloadData("resposta_json.json", dado_json, false);
    }

    function salvar_sql(){
        downloadData("comando_sql.txt", dado_sql, true);
    }

    function att_conteudo3_sql(comando_sql){
        dado_sql = comando_sql;
        var str = "<div><h4><button type=\"button\" class=\"botao_estilo\" onclick=\"salvar_sql()\">Download Comando SQL</button></h4></div>";
        document.getElementById("conteudo_botoes").innerHTML = (str);
    }

    function att_conteudo3_json_sql(comando_sql, dado){
        dado_json = dado;
        dado_sql = comando_sql;
        var str = "<div class = \"div_container\"><div style=\"padding-left: 350px;\"><h4><button type=\"button\" class=\"botao_estilo\" onclick=\"salvar_json()\">Download Arquivo JSON</button></div></h4>";
        str = str + ("<div style=\"padding-right: 350px;\"><h4><button type=\"button\" class=\"botao_estilo\" onclick=\"salvar_sql()\">Download Comando SQL</button></h4></div></div>");
        document.getElementById("conteudo_botoes").innerHTML = (str);
    }


    const carregar = () => fetch('/texto').then(response => response.json()).then(obj => {
        if(obj.tipo == 0){//mensagem simples de sucesso
            document.getElementById("conteudo1").innerHTML = ("<h2>Sucesso!</h2>");
            document.getElementById("mensagem").innerHTML = ("<form><h4>" + obj.texto + "</h4></form>");
            att_conteudo3_sql(obj.comando);
        } 
        else if(obj.tipo == 1){//mensagem de erro
            document.getElementById("conteudo1").innerHTML = ("<h2 style=\"color: brown;\">Falha!</h2>");
            document.getElementById("mensagem").innerHTML = ("<form><h4>" + obj.texto + "</h4></form>");
        }
        else if(obj.tipo == 2){//pesquisa por nome de autor
            document.getElementById("conteudo1").innerHTML = ("<h2>" + obj.texto + "</h2>");
            var dados = JSON.parse(obj.dados);
            var str = "";

            if(dados.length==0){
                str = "<form style=\"padding: 5px;\"><h4>A busca não encontrou resultados.</h4></form>";
            }
            else{
                for(var i=0; i<dados.length; i++){
                    str = str + ("<form style=\"padding: 5px;\"><div class=\"h6_1\">");
                    str = str + ("Identificador único: <font color=\"#FCC352\">" + dados[i].id_autor + "</font><br>");
                    str = str + ("Nome do autor: <font color=\"#FCC352\">" + dados[i].a_nome + "</font><br>");
                    str = str + ("Biografia: <font color=\"#FCC352\">" + dados[i].biografia + "</font><br>");
                    str = str + ("</div></form>");
                }
            }
            document.getElementById("conteudo2").innerHTML = (str);
            att_conteudo3_json_sql(obj.comando, obj.dados);
        }
        else if(obj.tipo == 3){//pesquisa por nome de editora
            document.getElementById("conteudo1").innerHTML = ("<h2>" + obj.texto + "</h2>");
            var dados = JSON.parse(obj.dados);
            var str = "";
            console.log(dados.length);
            if(dados.length==0){
                str = "<form style=\"padding: 5px;\"><h4>A busca não encontrou resultados.</h4></form>";
            }
            else{
                for(var i=0; i<dados.length; i++){
                    str = str + ("<form style=\"padding: 5px;\"><div class=\"h6_1\">");
                    str = str + ("Identificador único: <font color=\"#FCC352\">" + dados[i].id_editora + "</font><br>");
                    str = str + ("Nome da Editora: <font color=\"#FCC352\">" + dados[i].e_nome + "</font><br>");
                    str = str + ("Contato: <font color=\"#FCC352\">" + dados[i].contato + "</font><br>");
                    str = str + ("Endereço: <font color=\"#FCC352\">" + dados[i].endereco + "</font><br>");
                    str = str + ("</div></form>");
                }
            }
            document.getElementById("conteudo2").innerHTML = (str);
            att_conteudo3_json_sql(obj.comando, obj.dados);
        }
        else if(obj.tipo == 4){//pesquisa em livro
            document.getElementById("conteudo1").innerHTML = ("<h2>" + obj.texto + "</h2>");
            var dados = JSON.parse(obj.dados);
            var str = "";
            var pega;

            if(dados.length==0){
                str = "<form style=\"padding: 5px;\"><h4>A busca não encontrou resultados.</h4></form>";
            }
            else{
                pega = parseFloat(dados[0].preco).toFixed(2);
                str = str + ("<form style=\"padding: 5px;\"><div class=\"h6_1\">");
                str = str + ("ISBN: <font color=\"#FCC352\">" + dados[0].ISBN + "</font><br>");
                str = str + ("Título: <font color=\"#FCC352\">" + dados[0].titulo + "</font><br>");
                str = str + ("Data de publicação: <font color=\"#FCC352\">" + dados[0].data_publicacao + "</font><br>");
                str = str + ("Preço: <font color=\"#FCC352\">R$" + pega + "</font><br>");
                str = str + ("Número de páginas: <font color=\"#FCC352\">" + dados[0].num_paginas + "</font><br>");
                str = str + ("Nome da Editora: <font color=\"#FCC352\">" + dados[0].e_nome + "</font><br>");
                str = str + ("Descrição: <font color=\"#FCC352\">" + dados[0].descricao + "</font><br>");
                str = str + ("País: <font color=\"#FCC352\">" + dados[0].pais + "</font><br>");
                str = str + ("Autor(es): <font color=\"#FCC352\">" + dados[0].a_nome + "<br>");
                for(var i=1; i<dados.length; i++){
                    if(dados[i].ISBN != dados[i-1].ISBN){
                        pega = parseFloat(dados[0].preco).toFixed(2);;
                        str = str + ("</font></div></form>");
                        str = str + ("<form style=\"padding: 5px;\"><div class=\"h6_1\">");
                        str = str + ("ISBN: <font color=\"#FCC352\">" + dados[i].ISBN + "</font><br>");
                        str = str + ("Título: <font color=\"#FCC352\">" + dados[i].titulo + "</font><br>");
                        str = str + ("Data de publicação: <font color=\"#FCC352\">" + dados[i].data_publicacao + "</font><br>");
                        str = str + ("Preço: <font color=\"#FCC352\">R$" + pega + "</font><br>");
                        str = str + ("Número de páginas: <font color=\"#FCC352\">" + dados[i].num_paginas + "</font><br>");
                        str = str + ("Nome da Editora: <font color=\"#FCC352\">" + dados[i].e_nome + "</font><br>");
                        str = str + ("Descrição: <font color=\"#FCC352\">" + dados[i].descricao + "</font><br>");
                        str = str + ("País: <font color=\"#FCC352\">" + dados[i].pais + "</font><br>");
                        str = str + ("Autor(es): <font color=\"#FCC352\">" + dados[i].a_nome + "<br>");
                    }
                    else{
                        str = str + ("&emsp;&emsp;&emsp;&emsp; " + dados[i].a_nome + "<br>");
                    }
                }
                str = str + ("</div></form>");
            }
            document.getElementById("conteudo2").innerHTML = (str);
            att_conteudo3_json_sql(obj.comando, obj.dados);
        }
    })
    window.onload = carregar;
</script>
 
<div id="conteudo1"> </div>
<div id="conteudo_botoes"> </div>
<div id="conteudo2"> </div>
<div id="mensagem"> </div>
<form action="/" method="GET" style="border: 0px;">
    <h4><button type="submit" class="botao_estilo_voltar">Voltar para página inicial</button></h4>
</form>

